#include	<stdio.h>
#include	"defs.h"
#include	"global.h"

#define	MINPACKPSFONT	256	/* > MAXDVIFONT	*/
#define	NPACKPSCHARS	256

/* output a byte value in Hex */
extern char	*digit;
#define EMITH(h)  putc(*(digit+((h>>4)&0xF)),stdout),\
	putc(*(digit+(h&0xF)),stdout)

int curpsf = NONFONT;
char buf[256];
int packpsfont = MINPACKPSFONT-1;
int packpschar = NPACKPSCHARS-1;

char *	psfname(psf)
int psf;
{
    if(psf >= MINPACKPSFONT)
	sprintf(buf, "F%d", psf-MINPACKPSFONT);
    else
	sprintf(buf, "f%d", psf);
    return(buf);
}

setpsfont(ce)
struct char_entry *ce;
{
    register int psf;
    
    if(curpsf != (psf = ce->psfont))
    {
	printf("%s setfont\n", psfname(psf));
	printf("/kanjifont currentfont def\n");
	curpsf = psf;
    }
}


readpsfontinfo(fe)
struct font_entry *fe;
{
	OpenFontFile(fe);
	switch(fe->font_type) {
		/* pk font */
	case FT_PK:
		ReadPKFontInfo(fe, fe->font_file_id);
		return;
		/* pxl font */
	case FT_PXL:
		ReadPXLFontInfo(fe, fe->font_file_id);
		return;
		/* LaserWriter buit-in font */
	case FT_LWTEX:
	case FT_LW:
		break;
	}
}


psfontdict(fe, c)
struct font_entry *fe;
int c;
{
    char *lwfontname();
    void loadpkchar(), loadpxlchar();
    
    switch(fe->font_type)
    {
	/* pk font */
    case FT_PK:
	fontdict(fe, c, loadpkchar);
	break;
	/* pxl font */
    case FT_PXL:
	fontdict(fe, c, loadpxlchar);
	break;
	/* LaserWriter buit-in font */ /* not use */
    case FT_LWTEX:
    case FT_LW:
	/* do nothing */
	break;
    }
    return(fe->ch[c].psfont);
}

fontdict(fe, c, loadchar)
register struct font_entry *fe;
int c;
void (*loadchar)();
{
    register struct char_entry *ce;
	
    ce = &(fe->ch[c]);
    if(ce->pschar != NONCHAR)
	return;
    if(ce->where.fileOffset == NONEXISTANT) {
	ce->psfont = NONFONT;
	ce->pschar = DUMMYCHAR;
	return;
    }
    (*loadchar)(fe, c);
    EmitChar(fe, c);
    /* we should really free the space used by the PXL data after this
       point, but it is not large, and besides, we may want to be
       more clever in the future, about sending bitmaps.  So keep
       the data around */
}

EmitChar(fe, c)		/* output a character bitmap */
struct font_entry *fe;
int c;
{
    register struct char_entry *ce;
    int bytewidth, i;
    register int j;
    register unsigned char *sl;
    register int cc;
    float cw;       /* char width, in "dots" - we rely on PostScript maintaining sufficient accuracy */
	
    /* Output in PostScript coord system (y +ive up, x +ive right)
       (0,0) of char bitmap at lower left.  Output scan lines
       from bottom to top */
	
    ce = &(fe->ch[c]);
	
    /* open font dict before first char */
    if(fe->dic_pack)
    {
	if(++packpschar >= NPACKPSCHARS)
	{
	    packpsfont++;
	    packpschar = 0;
	}
	if(packpschar == 0)
	    printf("%d /%s newfont\n", NPACKPSCHARS, psfname(packpsfont));
	ce->psfont = packpsfont;
	ce->pschar = packpschar;
	}
    else
    {
	ce->psfont = fe->k;
	ce->pschar = c;
	if(fe->ncdl == 0)
	    printf("%d /%s newfont\n", fe->nfntchars, psfname(fe->k));
    }
    setpsfont(ce);
    prevfsize=0.0;      /* reset prev font size */
    
    printf("[<");
    bytewidth = (ce->width + 7) >> 3;
    for(i = ce->height-1, cc = 2;  i >= 0;  i--)
    {
	sl = (unsigned char *)(ce->where.pixptr + i*ce->nbpl);
	for(j = 0;  j < bytewidth;  j++, sl++)
	{
	    if( cc > 100 )
	    {
		printf("\n  ");
		cc = 2;
	    }
	    EMITH(*sl);
	    cc += 2;
	}
    }
    cw = (float)ce->tfmw / (float)hconv;
    printf("> %d %d %d %d %.3f] %d definechar\n", bytewidth<<3, ce->height, ce->xOffset, (((int)ce->height)-ce->yOffset)-1, cw, ce->pschar);
    fe->ncdl += 1;
}
